<template>
	<div class="keygen lightestpink-color">
		<div class="header flex space">	
			<div class="node-info">
				<div class="flex space v-top">
					<div class="type hustle medium lightest-pink-color">{{getLocale('structure_main_keygen')}}</div>
					<div class="level medium-font">LV{{node.data.level}}</div>
				</div>
				
				<v-button 
					v-if="node.data.level < structureMaxLevel('keygen')"
					:text="getLocale('upgrade')"
					:secondary_text="structureUpgradeCost('keygen', node.data.level)"
					:icons="[ 'bytes_black.svg' ]"
					:disabled="checkStructureByteCost('keygen', node.data.level)"
					color="lightestpink"
					@clicked="upgradeNode(node.id)"
				/>
			</div>
			
			<div class="level-bar">
				<div class="bar">
					<div class="base lightestpink-bkg" :style="{width : (4*node.data.level)+'%'}"></div>
				</div>
				
				<!--
				<div class="bonus" :class="{'active' : node.data.level >= 15}" :style="{left : '60%'}" v-tooltip="'keygen_perk_1'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV15</div>
					<div class="effect">{{getLocale('keygen_perk_1_label')}}</div>
				</div>
				-->
			</div>
			
			<tutorial-icon color="#feb3ff" @clicked="setTutorial('keygen', -1, true)"/>
		</div>
		
		<div class="align-center">
			<div class="description">{{getLocale('structure_main_keygen_effect')}}</div>
			
			<div class="content special flex space v-top" :class="[current_process != null ? 'active green-border green-color' : 'lightestpink-border ']">
				<div class="top-section uppercase">
					<div v-if="assigned_vairus" class="flex v-center space">
						<div>{{ parseTime(keygen_time*1000) }}</div>
						
						<div class="arrow">→</div>
						
						<div class="flex">
							<div>1</div>
							<div class="icon" :style="{ 'background-image' : getKeyImage(keytype) }"></div>
						</div>
					</div>
				</div>
				
				<div class="action uppercase black-color bold" :class="{assigned : assigned_vairus}">
					<div v-if="assigned_vairus">
						<div v-if="current_process == null" class="start green-bkg" v-on:click="startKeygen">
							{{ getLocale('start') }}
						</div>
						
						<div v-else class="stop lightestpink-bkg"  v-on:click="stopKeygen">
							{{ getLocale('cancel')}}
						</div>
					</div>
				</div>
				
				<div class="assignment">
					<div class="wrapper row-padding col-padding">
						<vairus-card 
							v-if="node.data.assignment"
							@clicked="requestList"
							:vairus="findVairus(node.data.assignment)"
							:highlighted="false"
							:show_footer="false"
							:hide_exhaustion="true"
							color="pink"
						/>
						
						<empty-card v-else @clicked="requestList" />
					</div>
					
					<div class="defrags" v-if="current_process" >
						<div class="fragment" v-for="n in 117" :style="{height : fragmentHeight(n)+'%'}">
							<div class="inner"></div>
						</div>
					</div>
				</div>
				
				<div class="bottom-section flex v-center h-center"></div>
				
				<v-info 
					class="efficiency" 
					:color="current_process == null ? '#FEB3FF' : '#00FFB4'" 
					:text="Math.floor(structureEffect('keygen', node.data.level)*100)+'%'" 
					v-tooltip="'main_efficiency_tooltip'"
				/>
				
				<v-info 
					v-if="current_process != null"
					class="time" 
					color="#00FFB4" 
					:text="parseTime(current_process.end*1000 - current_time)" 
				/>
			</div>
		</div>
	</div>
</template>


<script>
	import VButton from '../VButton.vue';
	import VInfo from '../VInfo.vue';
	import TutorialIcon from '../TutorialIcon.vue';
	import VairusCard from '../VairusCard.vue';
	import EmptyCard from '../EmptyCard.vue';
	import { commonMixin } from '../../mixins/common.js';
	import { structuresMixin } from '../../mixins/structures.js';
	import { storeGettersMixin } from '../../mixins/store_getters.js';
	import structuresManager from '../../classes/structuresManagerClass.js';
	import raritiesManager from '../../classes/raritiesManagerClass.js';
	
	var browser = browser || chrome;
	
	export default {
		props: ['node'],
		data: function () {
			return{
				gather_disabled : false,
				fragments_list : []
			}
		},
		computed: {
			assigned_vairus(){
				let vairus = this.vairus_list.find(function(v){
					return v.unique_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof vairus !== 'undefined') ? vairus : null;
			},
			current_process(){
				if(this.node.data.assignment == null) return null;
				
				let process = this.processes.find(function(p){
					return p.vairus_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof process !== 'undefined') ? process : null;
			},
			cur_frag(){
				let time = Math.floor(this.current_time/1000 - this.current_process.start)%900;
				return (117*time) / 900;
			},
			rarity(){
				return raritiesManager.getRarityByName(this.assigned_vairus.vairus_type.rarity);
			},
			keytype(){
				return this.rarity.id;
			},
			keygen_time(){
				let progress_required = 3000 * this.rarity.multiplier;
				
				let keygen_efficacy = this.structureEffect('keygen', this.node.data.level);
				keygen_efficacy = Math.round(keygen_efficacy*100);
				
				let stats = 0;
				
				for(var stat in this.assigned_vairus.current_stats){
					stats += this.assigned_vairus.current_stats[stat].total;
				}
				
				let vairus_efficacy = 1 + ((stats)/300);
				
				return Math.round((progress_required/(keygen_efficacy*vairus_efficacy))*3600);
			}
		},
		mounted(){
			for(var i=1; i<=117; i++){
				this.fragments_list.push(i);
			}
			this.fragments_list = this.shuffleArray(this.fragments_list);
		},
		methods: {
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(d > 0){
					return  d+'D '+h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			shuffleArray(array) {
				for (let i = array.length - 1; i > 0; i--) {
					const j = Math.floor(Math.random() * (i + 1));
					[array[i], array[j]] = [array[j], array[i]];
				}
				return array;
			},
			fragmentHeight(n){
			
				if(this.fragments_list[n] == Math.floor(this.cur_frag) ){
					return 100-100*(this.cur_frag%1);
				}
			
				if(this.fragments_list[n] < Math.floor(this.cur_frag) ){
					return 0;
				}
				
				return 100;				
			},
			startKeygen(){
				if(this.start_process_lock) return;
				this.$store.commit('setActionLock', 'start_process_lock');
				
				browser.runtime.sendMessage({
					type : 'start_node_process',
					data : { 
						node_id : this.node.id.replace('n', ''),
						type : 'keygen',
						cycle : 1
					}
				});
			},
			stopKeygen(){
				if(this.current_process != null){
					browser.runtime.sendMessage({
						type : 'stop_process',
						data : this.current_process.id
					});
				}
			},
			requestList(){
				if(this.current_process != null){
					if(confirm(this.getLocale('stop_process_warning'))){
						this.$emit('requestlist');
					}
				}else{
					this.$emit('requestlist');
				}
			}
		},
		mixins: [commonMixin, structuresMixin, storeGettersMixin],
		components: {
			VButton, VInfo, VairusCard, EmptyCard, TutorialIcon
		}
	}
</script>


<style lang="scss" scoped>
	@import "../../styles/variables";
	
	.keygen{
		.description{
			text-align: left;
			position: absolute;
			width: 200px;
		}
		
		.assignment{
			.vairus-card,
			.empty-card{
				margin: 0;
			}
			
			.defrags{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				display: grid;
				grid-gap: 5px;
				grid-template-columns: repeat(13, 1fr);
				grid-template-rows: repeat(9, 1fr);
				pointer-events: none;
				
				.fragment{
					position: relative;
					background-color: $darkgreen;
					opacity: 0.5;
					
					.inner{
						position: absolute;
						left: 0;
						width: 100%;
						bottom: 0;
						height: 100%;
						background: repeating-linear-gradient(0deg, rgba(0, 0, 0, 0.3), rgba(0, 0, 0, 0.3) 1px, transparent 6px, transparent 2px);
					}
				}
			}
		}
	
		.icon{
			margin-left: 10px;
			width: 20px;
			height: 20px;
			background-size: contain;
			background-repeat: no-repeat;
			background-position: center;
		}
			
		.progress{
			margin-top: 10px;
			
			.bar{
				position: relative;
				height: 12px;
				width: 50%;
				margin-top: 7px;
				border: 1px solid white;
				border-radius: 6px;
				overflow: hidden;
				
				.base{
					background-color: white;
					height: 100%;
				}
			}
		}
		@media screen and (max-width: 800px) {
			.description{
				width: 100%;
				text-align: right;
				right: 25px;
			}	
			.content{
				margin-top: 50px !important;
			}
		}	
		
		@media screen and (max-width: 700px) {
			.level-bar{
				display: none;
			}
			.header {
				margin-bottom: -20px !important;
			}
		}
		@media screen and (max-width: 400px) {
			.vairus-card{
				width: 175px;
				height: 250px;
			}
		}
	}
</style>








